/*=============DESKRIPTION===================
  The perpus of the program is to calculate the
  vector product of two unser inputet vectors.
  The program has a function(krisKross) 
  that contains the mathmatical logic 
  to calculate the vector product, it uses three
  diffrent arrays to store the user input.
 ============================================*/
#include <stdlib.h>
#include <stdio.h>
 /*declares a function with the logic to calculate the vector product
  by using three diffrent arrays*/
void krisKross(const double v1[3],const double v2[3], double result[3])
{
	result[0] = v1[1] * v2[2] - v1[2] * v2[1];
	result[1] = v1[2] * v2[0] - v1[0] * v2[2];
	result[2] = v1[0] * v2[1] - v1[1] * v2[0];
}

int main(int argc, char *argv[])
{
	if(argc != 7)
	{
		printf("invalid amount of input");
		return 1;
	}
	
	//declares all the arrays in the main function
	double v1[3];
	double v2[3];
	double result[3];
	
	//chcks commad line arguments
	for(int i = 1; i <= 3; i++)
	{
		//converts all the commandline arguments to duble arguments and then puts them in v1 and v2
		v1[i-1] = atof(argv[i]);
		v2[i-1] = atof(argv[i+3]);//+3 because the first three i values in the values in v1
	}
	
	krisKross(v1,v2,result);// runns the function with the inputet values 
	//printf("the vector product is: ");
	printf("%lf %lf %lf\n",result[0],result[1],result[2]);
	return 0;

}
/*======================TESTING======================
 test 1: testing with regular double input
 input: 1 2 3 3 2 1
   
 output:-4.000000,8.000000.-4.000000
 
 test 2: testing with to many numbers 
 input: 1 2 3 4 3 2 1 
 
 output: invalid input
 
 ====================================================*/
