#include <stdio.h>
#include <stdlib.h>
#include "list.h"
int add_after(double_list *list, double data)
{
	 Node *new_node = (Node *)malloc(sizeof(Node));

    if (new_node == NULL)
    {
        printf("Memory allocation error\n");
        exit(EXIT_FAILURE);
    }

    new_node->data = data;
    new_node->next = list->head;

    list->head = new_node;
    (list->size)++;

    return 1;
}
void reverse_list(double_list* list)
{
	Node* current = list -> head;
	Node* prev = NULL;
	Node* next = NULL;
	//gose thrught the list and reverses the order of the pointer 
	while(current != NULL)
	{
		next = current -> next;
		current -> next = prev;
		prev = current;
		current = next;
	}
	//sets the head of the list as the last node
	list -> head = prev;
}
//function to print the list
void print_list(double_list* list)
{
 Node* current = list -> head;
 //gose thrught the lsit and print every element
 while(current != NULL)
 {
	 printf("%.2f ",current -> data);
	 current = current -> next;
 }	
 printf("\n");
}
//the function frees the memory allocaded from the list
void free_list(double_list* list)
{
	Node* current = list -> head;
	// gose thrue the list and freese the memory from every node in list
	while(current != NULL)
	{
		Node* next = current -> next;
		free(current);
		current = next;
	}
}
