#include <stdio.h>
#include <stdlib.h>

//node struct for a likned list 
typedef struct Node
{
	double data;	 	//data for the node
	struct Node* next; //pointer to the next node in the list 
} Node;
// struct for a double_linked list 
typedef struct
{
	Node* head;		//pointer to the fist node in the list 
	int size; 	//the number of nodes in the list(the size)
} double_list;

//function to add a new node to the front of the list
int push_front(double_list* list, double data)
{
	Node* new_node =(Node*)malloc(sizeof(Node));//allcocates the memory for the new node
	//looks if there is no new node
	if(new_node==NULL)
	{
		printf("Node not found");
		exit(EXIT_FAILURE);
	}
	
	new_node -> data = data;//the new node is now the data 
	new_node -> next = NULL;//the node after that is set to NULL
	
	//if the list is empty set the new node to the head
	if(list-> head == NULL)
	{
		list -> head = new_node;
	}
	else
	{
	//gose thrught the whole list and adds the new node at the fornt
	Node* current = list -> head;
	 while( current -> next !=NULL)
	 {
		current = current -> next;
	 }
	 
	 new_node -> next = list -> head;
	 
	  list -> head = new_node;
	}
	//increses the size of the list
	(list -> size)++;

	return 1;
}
// function that reverses the order of the list	
void reverse_list(double_list* list)
{
	Node* current = list -> head;
	Node* prev = NULL;
	Node* next = NULL;
	//gose thrught the list and reverses the order of the pointer 
	while(current != NULL)
	{
		next = current -> next;
		current -> next = prev;
		prev = current;
		current = next;
	}
	//sets the head of the list as the last node
	list -> head = prev;
}
//function to print the list
void print_list(double_list* list)
{
 Node* current = list -> head;
 //gose thrught the lsit and print every element
 while(current != NULL)
 {
	 printf("%.2f ",current -> data);
	 current = current -> next;
 }	
 printf("\n");
}
//the function frees the memory allocaded from the list
void free_list(double_list* list)
{
	Node* current = list -> head;
	// gose thrue the list and freese the memory from every node in list
	while(current != NULL)
	{
		Node* next = current -> next;
		free(current);
		current = next;
	}
}
// main function
int main(int argc, char* argv[])
{
//cheks if there is a right amount of commandline arguments
if(argc < 2)
{
	printf("Inavlid amount of input");
	exit(EXIT_FAILURE);
}
	//creates a double-linked list 
	double_list L;
	L.head = NULL;
	L.size = 0;

	//adds the value of the commandline arguments to the list
	for(int i = 1; i < argc; i++)
	{
		double value = strtod(argv[i],NULL);
		//checks if the push_front poeration falis
		if(!push_front(&L,value))
		{
			printf("can't push\n");
			free_list(&L);
			exit(EXIT_FAILURE);
		}
	}
	print_list(&L);//prints the list

	exit(EXIT_SUCCESS);//exitts the proram as a succses
}
/*=============TESTING=================
 * Test 1 regular input:
 *input: ./task 1 10 20 30
 * output : 30 20 10
 * test 2: no input:
 * input:
 * output: "Inavlid amount of input"
 * test 3 wrong input:
 * input: ./task_1 a b c 
 * 0.00 0.00 0.00
  
 ======================================*/
