/*=================DISKRIPTION=========================
the gole of this program is to blur an pgm image by
manipulationg the pixel values of the image. The program
takes in pgm image and manipulats the pixels of the image
it dose this by first checks the surrounding pixles and
se if they exist, then it stors the avarge value in the
outputted image and by that blues it.
=======================================================*/
#include <stdlib.h>
#include <stdio.h>
typedef struct
{
	int w; //the width of the image
	int h; // the height of the image
	int maxval; //max value of pixel
	int p[500][500]; // pointer to the pixel data

} image;

//The function that reads an image from a file
void image_scan(const char *filename, image *img)
{
	//char src[] = "border.pgm";
	//open the file reading in binary
	FILE *file = fopen(filename, "r");
	if(file == NULL)
	{
		//an error message that comes up if the file can't be open
		fprintf(stderr, "genericf error message1 %s\n", filename);
		exit(EXIT_FAILURE);
	}

	//the default dimentions of the images

	//int maxVal;
	fscanf(file, "P2 %d %d %d",&(img ->w),&(img ->h),&(img -> maxval));// reads the maximun pixel value from the file

	//fgetc(file);// skips the newline character "\n" after the maxVal

	//img -> p[][] = (int *)malloc(img -> w * img->h * sizeof(int));// allocates memory from the image data
	int pixel;
	int count = 0;
	while(fscanf(file,"%d",&pixel)>0)
	{
		int col = count%(img->w);
		int row = count/(img->w);
		img->p[row][col]=pixel;
		printf("%d ",pixel);
		if(col==(img->w)-1) printf("\n");
		count++;
	}

	if(img -> p ==NULL)//if the memory allocation fails it prints a error message
	{
		fprintf(stderr,"generic error message2 %s\n", filename);
		exit(EXIT_FAILURE);
	}


	//fread(img -> p, sizeof(unsigned char), img -> w * img -> h,file);//read pixel data from the file

	fclose(file);//closes the file


}

void image_print(const char *filename, const image *img) {
	FILE *file = fopen(filename, "w");
	if (file == NULL) {
		fprintf(stderr, "Error opening file: %s\n", filename);
		exit(EXIT_FAILURE);
	}

	fprintf(file, "P2\n%d %d\n%d\n", img->w, img->h, img->maxval);

	for (int row = 0; row < img->h; row++) {
		for (int col = 0; col < img->w; col++) {
			fprintf(file, "%d ", img->p[row][col]);
		}
		fprintf(file, "\n");
	}

	fclose(file);
}

// the function that blurs the image
void blur(const image *in, image *out) {
	out->w = in->w;
	out->h = in->h;
	out->maxval = in->maxval;

	for (int row = 0; row < in->h; row++) {
		for (int col = 0; col < in->w; col++) {
			

			// the pixel is not on any border
			if ((row-1) >= 0 && (row+1) < in->h && (col-1) >= 0 && (col+1) < in->w) {
				out->p[row][col] = (in->p[row][col]+
									in->p[row-1][col]+
									in->p[row+1][col]+
									in->p[row][col-1]+
									in->p[row][col+1])/5;
				
			} else{
				int sum = in->p[row][col];
				int n = 1;
				
				//left 
				if((col-1) > (-1)){
					sum += in->p[row][col-1];
					n++;
				}
				//right
				if((col+1) < (in->w)){
					sum += in->p[row][col+1];
					n++;
				}
				//up
				if((row-1) > (-1)){
					sum += in->p[row-1][col];
					n++;
				}
				//down
				if((row+1) < (in->h)){
					sum += in->p[row+1][col];
					n++;
				}

				out->p[row][col] = sum/n;
			} 
			
			
			
				
			

			// Round to the nearest integer
			//out->p[row][col] = (int)(summ / n);

			// Cap pixel values to be within the range [0, in->maxval]
			//if (out->p[row][col] > in->maxval) {
			//	out->p[row][col] = in->maxval;
			//}
			//if (out->p[row][col] < 0) {
			//	out->p[row][col] = 0;
			//}
		}
	}
}
int main(int argc, char *argv[])
{	// checks if the user have inputet the correct input
	if(argc != 2) {

		//prints out 0error mesage if the user input is incorrect
		fprintf(stderr,"generic error message4 %s \n",argv[0]);
		exit(EXIT_FAILURE); //exits the program
	}

	//########
	/*FILE *file = fopen("border.pgm","r");
	if(file==NULL) printf("error\n");
	else {
		int outpo,ab,ba;
		printf("%d\n",fscanf(file,"P2 %d %d %d",&outpo,&ab,&ba));
		fclose(file);
		}
	//#3333333333333*/
	//declares input and an output imaghe
	image in_image;
	image out_image;

	image_scan(argv[1], &in_image);//reads the input image from the file th user inputed

	blur(&in_image, &out_image);//runns the blur function with the inputed image

	image_print("blur.pgm", &out_image);//gives the blured image the file name "blur.pgm"
	//image_print("blur.pgm", &in_image);

	//free(out_image.p);// frees the allcocated memory

	return EXIT_SUCCESS;// exits the program
}

