/*============DESKRIPTION=================
  similar to the first task but this time
  there is a pointer vareble that stores
  the result of the function sum
==========================================*/
#include <stdio.h>
#include <stdlib.h>

void sum(double num1, double num2, double *result)
{
	*result = (num1+num2);
}

int main(int argc, char *argv[]) {
	// checks if there is enough inputet arguments
	if (argc != 3) {
		printf("Missing input\n");// the error message
		return 0;
	}

	double num1 = atof(argv[1]);
	double num2 = atof(argv[2]);
	double result;// declares the result vareble in the main function

	sum(num1 , num2 , &result);
	printf("The sum of your Input is: ");
	printf("%.2f\n",result);
	return 1;
}
/* ================TESTING & RESULT================
 tests with whole numbers and floating points
 input:3.3 5
 output: The sum of your input is: 4.15

 testing with negative numbers
 input -2 -4
 output: 3

testing with no input
Input:
output:Missing input

 =============================================*/
