#include <stdio.h>
#include <stdlib.h>
#include "double_stack.h"

 struct Node
{
	double data;	 	//data for the node
	struct Node* next; //pointer to the next node in the list 
};

// struct for a double_linked list 
 struct double_stack_struct
{
	Node* head;		//pointer to the fist node in the list 
	int size; 	//the number of nodes in the list(the size)
};

double_stack* create_stack()
{
	double_stack* stack = malloc(sizeof(double_stack));
	return stack;
} 
int push( double_stack* stack, double d )
{
	Node* new_node =(Node*)malloc(sizeof(Node));
	
	
	new_node -> data = d; 
	new_node -> next = stack -> head;
	stack-> head = new_node; 
	
	(stack-> size)++;

	return 1; 
}

int pop( double_stack* stack, double *d)
{
	if((stack->head) == NULL)
	{
		printf("empty");
		return 0;
	}
	
	
	*d = stack -> head -> data;
	stack -> head = stack -> head -> next;
	return 1;
}

int add_after(double_stack *list, double data)
{
	 Node *new_node = (Node *)malloc(sizeof(Node));

    if (new_node == NULL)
    {
        printf("Memory allocation error\n");
        exit(EXIT_FAILURE);
    }

    new_node->data = data;
    new_node->next = list->head;

    list->head = new_node;
    (list->size)++;

    return 1;
}
void reverse_list(double_stack* list)
{
	Node* current = list -> head;
	Node* prev = NULL;
	Node* next = NULL;
	//gose thrught the list and reverses the order of the pointer 
	while(current != NULL)
	{
		next = current -> next;
		current -> next = prev;
		prev = current;
		current = next;
	}
	//sets the head of the list as the last node
	list -> head = prev;
}
//function to print the list
/*void print_list(double_stack* list)
{
 Node* current = list -> head;
 //gose thrught the lsit and print every element
 while(current != NULL)
 {
	 printf("%.2f ",current -> data);
	 current = current -> next;
 }	
 printf("\n");
}
*/
//the function frees the memory allocaded from the list
void free_list(double_stack* list)
{
	Node* current = list -> head;
	// gose thrue the list and freese the memory from every node in list
	while(current != NULL)
	{
		Node* next = current -> next;
		free(current);
		current = next;
	}
}

