#include <stdio.h>
#include <stdlib.h>
#include "list.h"
int main(int argc, char* argv[])
{
//cheks if there is a right amount of commandline arguments
if(argc < 2)
{
	printf("Inavlid amount of input");
	exit(EXIT_FAILURE);
}
	//creates a double-linked list 
	double_list L;
	L.head = NULL;
	L.size = 0;
	
	

	//adds the value of the commandline arguments to the list
	for(int i = 1; i < argc; i++)
	{
		double value = strtod(argv[i],NULL);
		if(i==1)
		{
			Node *new_node = (Node*)malloc(sizeof(Node));
			if(new_node ==NULL){
			printf("Allocation went wrong\n");
			free_list(&L);
			exit(EXIT_FAILURE);
			}
			
			new_node -> data = value;
			new_node ->next =NULL;
			L.head =new_node;
		}
		else
		{
			if(!add_after(&L,value))
			{
				printf("Can't add\n");
				free_list(&L);
				exit(EXIT_FAILURE);
			}
		}
		
	}
	reverse_list(&L);
	print_list(&L);//prints the list
	
	free_list(&L);

	exit(EXIT_SUCCESS);//exitts the proram as a succses
}
/*=============TESTING=================
  * Test 1: normal output
 * input ./task_3 1 2 3
 * output: 1.00 2.00 3.00
 * Test 2: no output
 * input: ./task_3
 * output: Inavlid amount of input
 * test 3 wrong input:
 * input: ./task_3 a b c 
 * 0.00 0.00 0.00
 ======================================*/
